using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Drag_n_Drop_Resigner
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        public string path = "";

        private void cmdResign_Click(object sender, EventArgs e)
        {
            //Resign Open Map
            Resign(path);
        }

        public void Resign(string path)
        {
            if (File.Exists(path))//Check That The File Exsists
            {
                //Open The File
                FileStream fs = new FileStream(path, FileMode.Open, FileAccess.ReadWrite, FileShare.ReadWrite);
                BinaryReader hr = new BinaryReader(fs);
                BinaryWriter hw = new BinaryWriter(fs);

                //Get/Set Required Data
                int size = (int)fs.Length - 2048;
                int times = size / 4;
                int result = 0;
                int x;

                //Get New Signature
                hr.BaseStream.Seek(2048, SeekOrigin.Begin);
                for (x = 0; x < times; x++)
                {
                    result ^= hr.ReadInt32();
                }

                //Write New Signature
                hw.BaseStream.Seek(720, SeekOrigin.Begin);
                hw.Write(result);
                hw.Flush();
                hr.Close();
                hw.Close();
                MessageBox.Show(path, "Resigned");
            }
            else
            {
                MessageBox.Show("No Map Is Open Or File Is Not A Halo 2 Map", "Error");
            }
        }

        private void cmdOpenMap_Click(object sender, EventArgs e)
        {
            //Show An Open Dialog To Get A Map Path
            OpenFileDialog OFD = new OpenFileDialog();
            OFD.Filter = "Halo 2 Map (*.map)|*.map";

            if (OFD.ShowDialog() == DialogResult.OK)
            {
                path = OFD.FileName;
            }
        }

        private void Main_DragEnter(object sender, DragEventArgs e)
        {
            //Set Effects, Dunno What This Does Really =P, But It Makes It Work XD
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.All;
            else
                e.Effect = DragDropEffects.None;
        }

        private void Main_DragDrop(object sender, DragEventArgs e)
        {
            string[] s = (string[])e.Data.GetData(DataFormats.FileDrop, false);//Get Array Of File Paths Which Were Dropped
            int i;
            //Loop Through File Paths And Resign Each
            for (i = 0; i < s.Length; i++)
                Resign(s[i]);
        }


    }
}